(* Traduction d'une expression rgulire en un automate *)

#open "genlex";;

(* Transformation d'une chane en liste de caractres *)
let listchar_of_string = 
  let rec aux i s =
    if (i = string_length s)
    then []
    else (Char s.[i])::(aux (i+1) s)
  in aux 0;;

(* Transformation d'un flux en liste *)
let rec list_of_stream = function
  | [< 'Ident s; list_of_stream q >] -> (listchar_of_string s)@q
  | [< 't; list_of_stream q >] -> t::q
  | [< >] -> []
;;

(* Automate. Les tats sont cods comme des entiers. *)
type Etat == int;;
type automate = { initial: Etat;
		            trans: (Etat * char) -> Etat ;
		            final: Etat };;
